# Program to apply a rotation matrix and a translation vector to a PDB file 

# Sets initial matrix as a list of lists, since it is a rotation matrix,
# we have the number of rows and number of columns equal to 3
rot_matrix = [[0]*3 for i in range(3)] 

# Sets initial vector as a list of three elements
vector = []

# Reads and opens input file
pdbFileIn = input("\nType the input PDB file name => ")
fo = open(pdbFileIn,"r")

# Reads and opens output file
pdbFileOut = input("\nType the output PDB file name => ")
fo_pdbOut = open(pdbFileOut,"w")

# Looping through to read elements of a number_of_rows X number_of_columns matrix
print("\nType elements of the rotation matrix")
for i in range(3) :
    for j in range(3) :
        print("Element [",i+1,"][",j+1,"] =>", end=" ")
        rot_matrix[i][j] = float(input() )

# Looping through to read translation vector
print("\nType the coordinates for the translation vector in Angstrom")
for i in range(3):
    print("Element [",i+1,"] =>", end=" ")
    translation = float(input())
    vector.append(translation)
 
# Shows rotation matrix
print("\nRotation matrix:")
for i in range(3) :
    for j in range(3) :
        print( rot_matrix[i][j], end = " ")
    print()
print()

# Shows translation vector
print("\nTranslation vector:")
for i in range(3) :
    print( vector[i], end = " ")
print()

# Reading line for "ATOM  " and "HETATM"
for line in fo:
    if line[0:6] == "ATOM  " or line[0:6] == "HETATM":
        x = float(line[30:38])*rot_matrix[0][0] + float(line[38:46])*rot_matrix[0][1] + float(line[46:54])*rot_matrix[0][2] + vector[0]
        y = float(line[30:38])*rot_matrix[1][0] + float(line[38:46])*rot_matrix[1][1] + float(line[46:54])*rot_matrix[1][2] + vector[1]
        z = float(line[30:38])*rot_matrix[2][0] + float(line[38:46])*rot_matrix[2][1] + float(line[46:54])*rot_matrix[2][2] + vector[2]
        line_out = line[0:30]+str( "%8.3f%8.3f%8.3f"%(x,y,z))+line[54:80]+"\n"
        fo_pdbOut.write(line_out)

# Closes files
fo.close()
fo_pdbOut.close() 