# Program to generate a plot for sine function using matplotlib and numpy. Plot is generated with labels and grid

# Imports packages and module
import matplotlib.pyplot as plt 
import numpy as np
import time

# Defines x range with linspace
x = np.linspace(0, 2*np.pi, 100)

# Defines sine function
sine_func = np.sin(x)

# Creates plot
plt.plot(x, sine_func)

plt.xlabel('x-axis')        # Adds axis label
plt.ylabel('y-axis')        # Adds axis label
plt.title('Sine Function')  # Adds title
plt.grid(True)              # Adds grid to the plot

# Shows plot
plt.show()

# Saves plot on png file
plt.savefig('sine2.png')

# Waits for 10 seconds to show plot on screen
time.sleep(10) 